from pyb import Pin, SPI, delay


class SSD1331:
    OLED_WIDTH = 96
    OLED_HEIGHT = 64

    FONT_1206 = 12
    FONT_1608 = 16

    DEACTIVE_SCROLLING = 0x2E
    
    SET_COLUMN_ADDRESS = 0x15
    SET_ROW_ADDRESS = 0x75
    SET_CONTRAST_A = 0x81
    SET_CONTRAST_B = 0x82
    SET_CONTRAST_C = 0x83
    MASTER_CURRENT_CONTROL = 0x87
    SET_PRECHARGE_SPEED_A = 0x8A
    SET_PRECHARGE_SPEED_B = 0x8B
    SET_PRECHARGE_SPEED_C = 0x8C
    SET_REMAP = 0xA0
    SET_DISPLAY_START_LINE = 0xA1
    SET_DISPLAY_OFFSET = 0xA2
    NORMAL_DISPLAY = 0xA4
    ENTIRE_DISPLAY_ON = 0xA5
    ENTIRE_DISPLAY_OFF = 0xA6
    INVERSE_DISPLAY = 0xA7
    SET_MULTIPLEX_RATIO = 0xA8
    DIM_MODE_SETTING = 0xAB
    SET_MASTER_CONFIGURE = 0xAD
    DIM_MODE_DISPLAY_ON = 0xAC
    DISPLAY_OFF = 0xAE
    NORMAL_BRIGHTNESS_DISPLAY_ON = 0xAF
    POWER_SAVE_MODE = 0xB0
    PHASE_PERIOD_ADJUSTMENT = 0xB1
    DISPLAY_CLOCK_DIV = 0xB3
    SET_GRAy_SCALE_TABLE = 0xB8
    ENABLE_LINEAR_GRAY_SCALE_TABLE = 0xB9
    SET_PRECHARGE_VOLTAGE = 0xBB
    SET_V_VOLTAGE = 0xBE

    # RGB(R,G,B)  (((R >> 3) << 11) | ((G >> 2) << 5) | (B >> 3))
    COLOR_NUM = {
        'black': 0,
        'grey': 50712,
        'white': 65536,
        'red': 63488,
        'pink': 65049,
        'yellow': 65504,
        'golden': 65184,
        'brown': 33093,
        'blue': 31,
        'cyan': 2047,
        'green': 2016,
        'purple': 41246
    }

    CHARACTERS_1608 = [	  
        [0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00], # " " 0
        [0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0xCC,0x00,0x0C,0x00,0x00,0x00,0x00,0x00,0x00], # "!" 1
        [0x00,0x00,0x08,0x00,0x30,0x00,0x60,0x00,0x08,0x00,0x30,0x00,0x60,0x00,0x00,0x00], # """ 2
        [0x02,0x20,0x03,0xFC,0x1E,0x20,0x02,0x20,0x03,0xFC,0x1E,0x20,0x02,0x20,0x00,0x00], # "#" 3
        [0x00,0x00,0x0E,0x18,0x11,0x04,0x3F,0xFF,0x10,0x84,0x0C,0x78,0x00,0x00,0x00,0x00], # "$" 4
        [0x0F,0x00,0x10,0x84,0x0F,0x38,0x00,0xC0,0x07,0x78,0x18,0x84,0x00,0x78,0x00,0x00], # "%" 5
        [0x00,0x78,0x0F,0x84,0x10,0xC4,0x11,0x24,0x0E,0x98,0x00,0xE4,0x00,0x84,0x00,0x08], # "&" 6
        [0x08,0x00,0x68,0x00,0x70,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00], # "'" 7
        [0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xE0,0x18,0x18,0x20,0x04,0x40,0x02,0x00,0x00], # "(" 8
        [0x00,0x00,0x40,0x02,0x20,0x04,0x18,0x18,0x07,0xE0,0x00,0x00,0x00,0x00,0x00,0x00], # ")" 9
        [0x02,0x40,0x02,0x40,0x01,0x80,0x0F,0xF0,0x01,0x80,0x02,0x40,0x02,0x40,0x00,0x00], # "*" 10
        [0x00,0x80,0x00,0x80,0x00,0x80,0x0F,0xF8,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0x00], # "+" 11
        [0x00,0x01,0x00,0x0D,0x00,0x0E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00], # "," 12
        [0x00,0x00,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0x80], # "-" 13
        [0x00,0x00,0x00,0x0C,0x00,0x0C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00], # "." 14
        [0x00,0x00,0x00,0x06,0x00,0x18,0x00,0x60,0x01,0x80,0x06,0x00,0x18,0x00,0x20,0x00], # "/" 15
        [0x00,0x00,0x07,0xF0,0x08,0x08,0x10,0x04,0x10,0x04,0x08,0x08,0x07,0xF0,0x00,0x00], # "0" 16
        [0x00,0x00,0x08,0x04,0x08,0x04,0x1F,0xFC,0x00,0x04,0x00,0x04,0x00,0x00,0x00,0x00], # "1" 17
        [0x00,0x00,0x0E,0x0C,0x10,0x14,0x10,0x24,0x10,0x44,0x11,0x84,0x0E,0x0C,0x00,0x00], # "2" 18
        [0x00,0x00,0x0C,0x18,0x10,0x04,0x11,0x04,0x11,0x04,0x12,0x88,0x0C,0x70,0x00,0x00], # "3" 19
        [0x00,0x00,0x00,0xE0,0x03,0x20,0x04,0x24,0x08,0x24,0x1F,0xFC,0x00,0x24,0x00,0x00], # "4" 20
        [0x00,0x00,0x1F,0x98,0x10,0x84,0x11,0x04,0x11,0x04,0x10,0x88,0x10,0x70,0x00,0x00], # "5" 21
        [0x00,0x00,0x07,0xF0,0x08,0x88,0x11,0x04,0x11,0x04,0x18,0x88,0x00,0x70,0x00,0x00], # "6" 22
        [0x00,0x00,0x1C,0x00,0x10,0x00,0x10,0xFC,0x13,0x00,0x1C,0x00,0x10,0x00,0x00,0x00], # "7" 23
        [0x00,0x00,0x0E,0x38,0x11,0x44,0x10,0x84,0x10,0x84,0x11,0x44,0x0E,0x38,0x00,0x00], # "8" 24
        [0x00,0x00,0x07,0x00,0x08,0x8C,0x10,0x44,0x10,0x44,0x08,0x88,0x07,0xF0,0x00,0x00], # "9" 25
        [0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x0C,0x03,0x0C,0x00,0x00,0x00,0x00,0x00,0x00], # ":" 26
        [0x00,0x00,0x00,0x00,0x00,0x01,0x01,0x06,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00], # ";" 27
        [0x00,0x00,0x00,0x80,0x01,0x40,0x02,0x20,0x04,0x10,0x08,0x08,0x10,0x04,0x00,0x00], # "<" 28
        [0x02,0x20,0x02,0x20,0x02,0x20,0x02,0x20,0x02,0x20,0x02,0x20,0x02,0x20,0x00,0x00], # "=" 29
        [0x00,0x00,0x10,0x04,0x08,0x08,0x04,0x10,0x02,0x20,0x01,0x40,0x00,0x80,0x00,0x00], # ">" 30
        [0x00,0x00,0x0E,0x00,0x12,0x00,0x10,0x0C,0x10,0x6C,0x10,0x80,0x0F,0x00,0x00,0x00], # "?" 31
        [0x03,0xE0,0x0C,0x18,0x13,0xE4,0x14,0x24,0x17,0xC4,0x08,0x28,0x07,0xD0,0x00,0x00], # "@" 32
        [0x00,0x04,0x00,0x3C,0x03,0xC4,0x1C,0x40,0x07,0x40,0x00,0xE4,0x00,0x1C,0x00,0x04], # "A" 33
        [0x10,0x04,0x1F,0xFC,0x11,0x04,0x11,0x04,0x11,0x04,0x0E,0x88,0x00,0x70,0x00,0x00], # "B" 34
        [0x03,0xE0,0x0C,0x18,0x10,0x04,0x10,0x04,0x10,0x04,0x10,0x08,0x1C,0x10,0x00,0x00], # "C" 35
        [0x10,0x04,0x1F,0xFC,0x10,0x04,0x10,0x04,0x10,0x04,0x08,0x08,0x07,0xF0,0x00,0x00], # "D" 36
        [0x10,0x04,0x1F,0xFC,0x11,0x04,0x11,0x04,0x17,0xC4,0x10,0x04,0x08,0x18,0x00,0x00], # "E" 37
        [0x10,0x04,0x1F,0xFC,0x11,0x04,0x11,0x00,0x17,0xC0,0x10,0x00,0x08,0x00,0x00,0x00], # "F" 38
        [0x03,0xE0,0x0C,0x18,0x10,0x04,0x10,0x04,0x10,0x44,0x1C,0x78,0x00,0x40,0x00,0x00], # "G" 39
        [0x10,0x04,0x1F,0xFC,0x10,0x84,0x00,0x80,0x00,0x80,0x10,0x84,0x1F,0xFC,0x10,0x04], # "H" 40
        [0x00,0x00,0x10,0x04,0x10,0x04,0x1F,0xFC,0x10,0x04,0x10,0x04,0x00,0x00,0x00,0x00], # "I" 41
        [0x00,0x03,0x00,0x01,0x10,0x01,0x10,0x01,0x1F,0xFE,0x10,0x00,0x10,0x00,0x00,0x00], # "J" 42
        [0x10,0x04,0x1F,0xFC,0x11,0x04,0x03,0x80,0x14,0x64,0x18,0x1C,0x10,0x04,0x00,0x00], # "K" 43
        [0x10,0x04,0x1F,0xFC,0x10,0x04,0x00,0x04,0x00,0x04,0x00,0x04,0x00,0x0C,0x00,0x00], # "L" 44
        [0x10,0x04,0x1F,0xFC,0x1F,0x00,0x00,0xFC,0x1F,0x00,0x1F,0xFC,0x10,0x04,0x00,0x00], # "M" 45
        [0x10,0x04,0x1F,0xFC,0x0C,0x04,0x03,0x00,0x00,0xE0,0x10,0x18,0x1F,0xFC,0x10,0x00], # "N" 46
        [0x07,0xF0,0x08,0x08,0x10,0x04,0x10,0x04,0x10,0x04,0x08,0x08,0x07,0xF0,0x00,0x00], # "O" 47
        [0x10,0x04,0x1F,0xFC,0x10,0x84,0x10,0x80,0x10,0x80,0x10,0x80,0x0F,0x00,0x00,0x00], # "P" 48
        [0x07,0xF0,0x08,0x18,0x10,0x24,0x10,0x24,0x10,0x1C,0x08,0x0A,0x07,0xF2,0x00,0x00], # "Q" 49
        [0x10,0x04,0x1F,0xFC,0x11,0x04,0x11,0x00,0x11,0xC0,0x11,0x30,0x0E,0x0C,0x00,0x04], # "R" 50
        [0x00,0x00,0x0E,0x1C,0x11,0x04,0x10,0x84,0x10,0x84,0x10,0x44,0x1C,0x38,0x00,0x00], # "S" 51
        [0x18,0x00,0x10,0x00,0x10,0x04,0x1F,0xFC,0x10,0x04,0x10,0x00,0x18,0x00,0x00,0x00], # "T" 52
        [0x10,0x00,0x1F,0xF8,0x10,0x04,0x00,0x04,0x00,0x04,0x10,0x04,0x1F,0xF8,0x10,0x00], # "U" 53
        [0x10,0x00,0x1E,0x00,0x11,0xE0,0x00,0x1C,0x00,0x70,0x13,0x80,0x1C,0x00,0x10,0x00], # "V" 54
        [0x1F,0xC0,0x10,0x3C,0x00,0xE0,0x1F,0x00,0x00,0xE0,0x10,0x3C,0x1F,0xC0,0x00,0x00], # "W" 55
        [0x10,0x04,0x18,0x0C,0x16,0x34,0x01,0xC0,0x01,0xC0,0x16,0x34,0x18,0x0C,0x10,0x04], # "X" 56
        [0x10,0x00,0x1C,0x00,0x13,0x04,0x00,0xFC,0x13,0x04,0x1C,0x00,0x10,0x00,0x00,0x00], # "Y" 57
        [0x08,0x04,0x10,0x1C,0x10,0x64,0x10,0x84,0x13,0x04,0x1C,0x04,0x10,0x18,0x00,0x00], # "Z" 58
        [0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0xFE,0x40,0x02,0x40,0x02,0x40,0x02,0x00,0x00], # "[" 59
        [0x00,0x00,0x30,0x00,0x0C,0x00,0x03,0x80,0x00,0x60,0x00,0x1C,0x00,0x03,0x00,0x00], # "\" 60
        [0x00,0x00,0x40,0x02,0x40,0x02,0x40,0x02,0x7F,0xFE,0x00,0x00,0x00,0x00,0x00,0x00], # "]" 61
        [0x00,0x00,0x00,0x00,0x20,0x00,0x40,0x00,0x40,0x00,0x40,0x00,0x20,0x00,0x00,0x00], # "^" 62
        [0x00,0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x00,0x01], # "_" 63
        [0x00,0x00,0x40,0x00,0x40,0x00,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00], # "`" 64
        [0x00,0x00,0x00,0x98,0x01,0x24,0x01,0x44,0x01,0x44,0x01,0x44,0x00,0xFC,0x00,0x04], # "a" 65
        [0x10,0x00,0x1F,0xFC,0x00,0x88,0x01,0x04,0x01,0x04,0x00,0x88,0x00,0x70,0x00,0x00], # "b" 66
        [0x00,0x00,0x00,0x70,0x00,0x88,0x01,0x04,0x01,0x04,0x01,0x04,0x00,0x88,0x00,0x00], # "c" 67
        [0x00,0x00,0x00,0x70,0x00,0x88,0x01,0x04,0x01,0x04,0x11,0x08,0x1F,0xFC,0x00,0x04], # "d" 68
        [0x00,0x00,0x00,0xF8,0x01,0x44,0x01,0x44,0x01,0x44,0x01,0x44,0x00,0xC8,0x00,0x00], # "e" 69
        [0x00,0x00,0x01,0x04,0x01,0x04,0x0F,0xFC,0x11,0x04,0x11,0x04,0x11,0x00,0x18,0x00], # "f" 70
        [0x00,0x00,0x00,0xD6,0x01,0x29,0x01,0x29,0x01,0x29,0x01,0xC9,0x01,0x06,0x00,0x00], # "g" 71
        [0x10,0x04,0x1F,0xFC,0x00,0x84,0x01,0x00,0x01,0x00,0x01,0x04,0x00,0xFC,0x00,0x04], # "h" 72
        [0x00,0x00,0x01,0x04,0x19,0x04,0x19,0xFC,0x00,0x04,0x00,0x04,0x00,0x00,0x00,0x00], # "i" 73
        [0x00,0x00,0x00,0x03,0x00,0x01,0x01,0x01,0x19,0x01,0x19,0xFE,0x00,0x00,0x00,0x00], # "j" 74
        [0x10,0x04,0x1F,0xFC,0x00,0x24,0x00,0x40,0x01,0xB4,0x01,0x0C,0x01,0x04,0x00,0x00], # "k" 75
        [0x00,0x00,0x10,0x04,0x10,0x04,0x1F,0xFC,0x00,0x04,0x00,0x04,0x00,0x00,0x00,0x00], # "l" 76
        [0x01,0x04,0x01,0xFC,0x01,0x04,0x01,0x00,0x01,0xFC,0x01,0x04,0x01,0x00,0x00,0xFC], # "m" 77
        [0x01,0x04,0x01,0xFC,0x00,0x84,0x01,0x00,0x01,0x00,0x01,0x04,0x00,0xFC,0x00,0x04], # "n" 78
        [0x00,0x00,0x00,0xF8,0x01,0x04,0x01,0x04,0x01,0x04,0x01,0x04,0x00,0xF8,0x00,0x00], # "o" 79
        [0x01,0x01,0x01,0xFF,0x00,0x85,0x01,0x04,0x01,0x04,0x00,0x88,0x00,0x70,0x00,0x00], # "p" 80
        [0x00,0x00,0x00,0x70,0x00,0x88,0x01,0x04,0x01,0x04,0x01,0x05,0x01,0xFF,0x00,0x01], # "q" 81
        [0x01,0x04,0x01,0x04,0x01,0xFC,0x00,0x84,0x01,0x04,0x01,0x00,0x01,0x80,0x00,0x00], # "r" 82
        [0x00,0x00,0x00,0xCC,0x01,0x24,0x01,0x24,0x01,0x24,0x01,0x24,0x01,0x98,0x00,0x00], # "s" 83
        [0x00,0x00,0x01,0x00,0x01,0x00,0x07,0xF8,0x01,0x04,0x01,0x04,0x00,0x00,0x00,0x00], # "t" 84
        [0x01,0x00,0x01,0xF8,0x00,0x04,0x00,0x04,0x00,0x04,0x01,0x08,0x01,0xFC,0x00,0x04], # "u" 85
        [0x01,0x00,0x01,0x80,0x01,0x70,0x00,0x0C,0x00,0x10,0x01,0x60,0x01,0x80,0x01,0x00], # "v" 86
        [0x01,0xF0,0x01,0x0C,0x00,0x30,0x01,0xC0,0x00,0x30,0x01,0x0C,0x01,0xF0,0x01,0x00], # "w" 87
        [0x00,0x00,0x01,0x04,0x01,0x8C,0x00,0x74,0x01,0x70,0x01,0x8C,0x01,0x04,0x00,0x00], # "x" 88
        [0x01,0x01,0x01,0x81,0x01,0x71,0x00,0x0E,0x00,0x18,0x01,0x60,0x01,0x80,0x01,0x00], # "y" 89
        [0x00,0x00,0x01,0x84,0x01,0x0C,0x01,0x34,0x01,0x44,0x01,0x84,0x01,0x0C,0x00,0x00], # "z" 90
        [0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x00,0x3E,0xFC,0x40,0x02,0x40,0x02], # "{" 91
        [0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00], # "|" 92
        [0x00,0x00,0x40,0x02,0x40,0x02,0x3E,0xFC,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00], # "}" 93
        [0x00,0x00,0x60,0x00,0x80,0x00,0x80,0x00,0x40,0x00,0x40,0x00,0x20,0x00,0x20,0x00], # "~" 94
    ]

    def __init__(self, spi_id=1, baudrate=100, cs='PC5', dc='PB1', res='PE7'):
        self.spi = SPI(spi_id, SPI.MASTER, polarity=1, phase=1, bits=8, \
            firstbit=SPI.MSB, ti=False, crc=None)  # configure as master
        self.cs = Pin(cs, mode=Pin.OUT_PP)
        self.dc = Pin(dc, mode=Pin.OUT_PP)
        self.res = Pin(res, mode=Pin.OUT_PP)
        self.background_color = 'black'

    def _write_byte(self, data, cmd=False):
        if cmd:
            self.dc.value(0)
        else:
            self.dc.value(1)

        self.cs.value(0)

        self.spi.send(bytes([data]), timeout=1000)

        self.cs.value(1)
        self.dc.value(1)

    def init(self):
        self.res.value(1)
        self.cs.value(1)

        self._write_byte(self.DISPLAY_OFF, cmd=True)  # Display Off
        self._write_byte(self.SET_CONTRAST_A, cmd=True)  # Set contrast for color A
        self._write_byte(0xFF, cmd=True)  # 145 0x91
        self._write_byte(self.SET_CONTRAST_B, cmd=True)  # Set contrast for color B
        self._write_byte(0xFF, cmd=True)  # 80 0x50
        self._write_byte(self.SET_CONTRAST_C, cmd=True)  # Set contrast for color C
        self._write_byte(0xFF, cmd=True)  # 125 0x7D
        self._write_byte(self.MASTER_CURRENT_CONTROL, cmd=True)  # master current control
        self._write_byte(0x06, cmd=True)  # 6
        self._write_byte(self.SET_PRECHARGE_SPEED_A, cmd=True)  # Set Second Pre-change Speed For ColorA
        self._write_byte(0x64, cmd=True)  # 100
        self._write_byte(self.SET_PRECHARGE_SPEED_B, cmd=True)  # Set Second Pre-change Speed For ColorB
        self._write_byte(0x78, cmd=True)  # 120
        self._write_byte(self.SET_PRECHARGE_SPEED_C, cmd=True)  # Set Second Pre-change Speed For ColorC
        self._write_byte(0x64, cmd=True)  # 100
        self._write_byte(self.SET_REMAP, cmd=True)  # set remap & data format
        self._write_byte(0x72, cmd=True)  # 0x72              
        self._write_byte(self.SET_DISPLAY_START_LINE, cmd=True)  # Set display Start Line
        self._write_byte(0x0, cmd=True)
        self._write_byte(self.SET_DISPLAY_OFFSET, cmd=True)  # Set display offset
        self._write_byte(0x0, cmd=True)
        self._write_byte(self.NORMAL_DISPLAY, cmd=True)  # Set display mode
        self._write_byte(self.SET_MULTIPLEX_RATIO, cmd=True)  # Set multiplex ratio
        self._write_byte(0x3F, cmd=True)
        self._write_byte(self.SET_MASTER_CONFIGURE, cmd=True)  # Set master configuration
        self._write_byte(0x8E, cmd=True)
        self._write_byte(self.POWER_SAVE_MODE, cmd=True)  # Set Power Save Mode
        self._write_byte(0x00, cmd=True)  # 0x00
        self._write_byte(self.PHASE_PERIOD_ADJUSTMENT, cmd=True)  # phase 1 and 2 period adjustment
        self._write_byte(0x31, cmd=True)  # 0x31
        self._write_byte(self.DISPLAY_CLOCK_DIV, cmd=True)  # display clock divider/oscillator frequency
        self._write_byte(0xF0, cmd=True)
        self._write_byte(self.SET_PRECHARGE_VOLTAGE, cmd=True)  # Set Pre-Change Level
        self._write_byte(0x3A, cmd=True)
        self._write_byte(self.SET_V_VOLTAGE, cmd=True)  # Set vcomH
        self._write_byte(0x3E, cmd=True)
        self._write_byte(self.DEACTIVE_SCROLLING, cmd=True)  # disable scrolling
        self._write_byte(self.NORMAL_BRIGHTNESS_DISPLAY_ON, cmd=True)  # set display on

        self.clear_screen('black')

    def _draw_point(self, x_pos, y_pos, color):
        if (x_pos < 0) or (x_pos >= self.OLED_WIDTH) \
            or (y_pos < 0) or (y_pos >= self.OLED_HEIGHT):
            return

        # set column point
        self._write_byte(self.SET_COLUMN_ADDRESS, cmd=True)
        self._write_byte(x_pos, cmd=True)
        self._write_byte(self.OLED_WIDTH - 1, cmd=True)
        # set row point
        self._write_byte(self.SET_ROW_ADDRESS, cmd=True)
        self._write_byte(y_pos, cmd=True)
        self._write_byte(self.OLED_HEIGHT - 1, cmd=True)

        # fill 16bit colour
        self._write_byte((color & 0xFF00) >> 8)
        self._write_byte(color & 0x00FF)

    def clear_screen(self, color):
        self.background_color = color
        color_num = self.COLOR_NUM[color]
        for i in range(0, self.OLED_WIDTH):
            for j in range(0, self.OLED_HEIGHT):
                self._draw_point(i, j, color_num)

    def display_char(self, x_pos, y_pos, character, color, font=FONT_1608):
        if (x_pos < 0) or (x_pos >= self.OLED_WIDTH) \
            or (y_pos < 0) or (y_pos >= self.OLED_HEIGHT):
            return

        y_pos_0 = y_pos
        color_num = self.COLOR_NUM[color]

        for i in range(0, font):
            if font == self.FONT_1608:
                character_num = self.CHARACTERS_1608[ord(character) - 0x20][i]
            else:
                break

            for j in range(0, 8):
                if character_num & 0x80:
                    self._draw_point(x_pos, y_pos, color_num)

                character_num <<= 1
                y_pos += 1
                if (y_pos - y_pos_0) == font:
                    y_pos = y_pos_0
                    x_pos += 1
                    break

    def display_text(self, x_pos, y_pos, text, color, font=FONT_1608):
        if (x_pos < 0) or (x_pos >= self.OLED_WIDTH) \
            or (y_pos < 0) or (y_pos >= self.OLED_HEIGHT):
            return

        for character in text:
            if x_pos > (self.OLED_WIDTH - font / 2):
                x_pos = 0
                y_pos += font
                if y_pos > (self.OLED_HEIGHT - font):
                    x_pos = 0
                    y_pos = 0
                    self.clear_screen(self.background_color)

            self.display_char(x_pos, y_pos, character, color, font)
            x_pos += int(font / 2)

